// Copyright 2016-2017 Amazon.com, Inc. or its affiliates. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License"). You may
// not use this file except in compliance with the License. A copy of the
// License is located at
//
//     http://aws.amazon.com/apache2.0/
//
// or in the "license" file accompanying this file. This file is distributed
// on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
// express or implied. See the License for the specific language governing
// permissions and limitations under the License.

// Automatically generated by MockGen. DO NOT EDIT!
// Source: pkg/deployment/deployment_service.go

package mocks

import (
	context "context"
	types0 "github.com/blox/blox/daemon-scheduler/pkg/deployment/types"
	types "github.com/blox/blox/daemon-scheduler/pkg/store/types"
	gomock "github.com/golang/mock/gomock"
)

// Mock of DeploymentService interface
type MockDeploymentService struct {
	ctrl     *gomock.Controller
	recorder *_MockDeploymentServiceRecorder
}

// Recorder for MockDeploymentService (not exported)
type _MockDeploymentServiceRecorder struct {
	mock *MockDeploymentService
}

func NewMockDeploymentService(ctrl *gomock.Controller) *MockDeploymentService {
	mock := &MockDeploymentService{ctrl: ctrl}
	mock.recorder = &_MockDeploymentServiceRecorder{mock}
	return mock
}

func (_m *MockDeploymentService) EXPECT() *_MockDeploymentServiceRecorder {
	return _m.recorder
}

func (_m *MockDeploymentService) CreateDeployment(ctx context.Context, environmentName string, token string) (*types0.Deployment, error) {
	ret := _m.ctrl.Call(_m, "CreateDeployment", ctx, environmentName, token)
	ret0, _ := ret[0].(*types0.Deployment)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

func (_mr *_MockDeploymentServiceRecorder) CreateDeployment(arg0, arg1, arg2 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "CreateDeployment", arg0, arg1, arg2)
}

func (_m *MockDeploymentService) CreateSubDeployment(ctx context.Context, environmentName string, instanceARNs []*string) (*types0.Deployment, error) {
	ret := _m.ctrl.Call(_m, "CreateSubDeployment", ctx, environmentName, instanceARNs)
	ret0, _ := ret[0].(*types0.Deployment)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

func (_mr *_MockDeploymentServiceRecorder) CreateSubDeployment(arg0, arg1, arg2 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "CreateSubDeployment", arg0, arg1, arg2)
}

func (_m *MockDeploymentService) StartDeployment(ctx context.Context, environmentName string, instanceARNs []*string) (*types0.Deployment, error) {
	ret := _m.ctrl.Call(_m, "StartDeployment", ctx, environmentName, instanceARNs)
	ret0, _ := ret[0].(*types0.Deployment)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

func (_mr *_MockDeploymentServiceRecorder) StartDeployment(arg0, arg1, arg2 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "StartDeployment", arg0, arg1, arg2)
}

func (_m *MockDeploymentService) UpdateInProgressDeployment(ctx context.Context, environmentName string, deployment *types0.Deployment) error {
	ret := _m.ctrl.Call(_m, "UpdateInProgressDeployment", ctx, environmentName, deployment)
	ret0, _ := ret[0].(error)
	return ret0
}

func (_mr *_MockDeploymentServiceRecorder) UpdateInProgressDeployment(arg0, arg1, arg2 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "UpdateInProgressDeployment", arg0, arg1, arg2)
}

func (_m *MockDeploymentService) GetDeployment(ctx context.Context, environmentName string, id string) (*types0.Deployment, error) {
	ret := _m.ctrl.Call(_m, "GetDeployment", ctx, environmentName, id)
	ret0, _ := ret[0].(*types0.Deployment)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

func (_mr *_MockDeploymentServiceRecorder) GetDeployment(arg0, arg1, arg2 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "GetDeployment", arg0, arg1, arg2)
}

func (_m *MockDeploymentService) GetCurrentDeployment(ctx context.Context, environmentName string) (*types0.Deployment, error) {
	ret := _m.ctrl.Call(_m, "GetCurrentDeployment", ctx, environmentName)
	ret0, _ := ret[0].(*types0.Deployment)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

func (_mr *_MockDeploymentServiceRecorder) GetCurrentDeployment(arg0, arg1 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "GetCurrentDeployment", arg0, arg1)
}

func (_m *MockDeploymentService) GetPendingDeployment(ctx context.Context, environmentName string) (*types0.Deployment, error) {
	ret := _m.ctrl.Call(_m, "GetPendingDeployment", ctx, environmentName)
	ret0, _ := ret[0].(*types0.Deployment)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

func (_mr *_MockDeploymentServiceRecorder) GetPendingDeployment(arg0, arg1 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "GetPendingDeployment", arg0, arg1)
}

func (_m *MockDeploymentService) GetInProgressDeployment(ctx context.Context, environmentName string) (*types0.Deployment, error) {
	ret := _m.ctrl.Call(_m, "GetInProgressDeployment", ctx, environmentName)
	ret0, _ := ret[0].(*types0.Deployment)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

func (_mr *_MockDeploymentServiceRecorder) GetInProgressDeployment(arg0, arg1 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "GetInProgressDeployment", arg0, arg1)
}

func (_m *MockDeploymentService) ListDeploymentsSortedReverseChronologically(ctx context.Context, environmentName string) ([]types0.Deployment, error) {
	ret := _m.ctrl.Call(_m, "ListDeploymentsSortedReverseChronologically", ctx, environmentName)
	ret0, _ := ret[0].([]types0.Deployment)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

func (_mr *_MockDeploymentServiceRecorder) ListDeploymentsSortedReverseChronologically(arg0, arg1 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "ListDeploymentsSortedReverseChronologically", arg0, arg1)
}

func (_m *MockDeploymentService) ValidateAndCreateDeployment(token string) (types.ValidateAndUpdateEnvironment, *types0.Deployment) {
	ret := _m.ctrl.Call(_m, "ValidateAndCreateDeployment", token)
	ret0, _ := ret[0].(types.ValidateAndUpdateEnvironment)
	ret1, _ := ret[1].(*types0.Deployment)
	return ret0, ret1
}

func (_mr *_MockDeploymentServiceRecorder) ValidateAndCreateDeployment(arg0 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "ValidateAndCreateDeployment", arg0)
}

func (_m *MockDeploymentService) ValidateAndCreateSubDeployment(instanceARNs []*string) (types.ValidateAndUpdateEnvironment, *types0.Deployment) {
	ret := _m.ctrl.Call(_m, "ValidateAndCreateSubDeployment", instanceARNs)
	ret0, _ := ret[0].(types.ValidateAndUpdateEnvironment)
	ret1, _ := ret[1].(*types0.Deployment)
	return ret0, ret1
}

func (_mr *_MockDeploymentServiceRecorder) ValidateAndCreateSubDeployment(arg0 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "ValidateAndCreateSubDeployment", arg0)
}

func (_m *MockDeploymentService) ValidateAndStartDeployment(instanceARNs []*string) (types.ValidateAndUpdateEnvironment, *types0.Deployment) {
	ret := _m.ctrl.Call(_m, "ValidateAndStartDeployment", instanceARNs)
	ret0, _ := ret[0].(types.ValidateAndUpdateEnvironment)
	ret1, _ := ret[1].(*types0.Deployment)
	return ret0, ret1
}

func (_mr *_MockDeploymentServiceRecorder) ValidateAndStartDeployment(arg0 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "ValidateAndStartDeployment", arg0)
}

func (_m *MockDeploymentService) ValidateAndUpdateInProgressDeployment(deployment *types0.Deployment) types.ValidateAndUpdateEnvironment {
	ret := _m.ctrl.Call(_m, "ValidateAndUpdateInProgressDeployment", deployment)
	ret0, _ := ret[0].(types.ValidateAndUpdateEnvironment)
	return ret0
}

func (_mr *_MockDeploymentServiceRecorder) ValidateAndUpdateInProgressDeployment(arg0 interface{}) *gomock.Call {
	return _mr.mock.ctrl.RecordCall(_mr.mock, "ValidateAndUpdateInProgressDeployment", arg0)
}
